diff -ruN ../nakedmudv2.7/src/cmd_comm.c src/cmd_comm.c
--- ../nakedmudv2.7/src/cmd_comm.c	Sun Jul 31 17:13:52 2005
+++ src/cmd_comm.c	Fri Oct  7 14:15:55 2005
@@ -9,18 +9,10 @@
 
 #include "mud.h"
 #include "utils.h"
-#include "handler.h"
 #include "inform.h"
 #include "character.h"
 #include "world.h"
-#include "dialog.h"
-
-
-
-//*****************************************************************************
-// mandatory modules
-//*****************************************************************************
-#include "scripts/script.h"
+#include "hooks.h"
 
 
 
@@ -28,57 +20,24 @@
 // cmd_ask is used to pose a question to another character. Mostly, this is
 // intended to be used to carry on dialogs with NPCs. Ask has a local range
 // (i.e. you can only ask people in the same room as you questions)
-//   usage: ask [person] <about> [question]
+//   usage: ask <person> [about] <question>
 //
 //   examples:
 //     ask bob about cats           ask bob about the topic, "cats"
 //     ask jim can I have a salad?  ask jim if you can have a salad
-COMMAND(cmd_ask)
-{
-  if(!arg || !*arg)
-    send_to_char(ch, "Ask who what?\r\n");
-  else {
-    bool ask_about = FALSE;
-    char name[MAX_BUFFER];
-    arg = one_arg(arg, name);
-    trim(arg);
-
-    // skip the "about" part in "ask [person] about"
-    if(!strncasecmp(arg, "about ", 6)) {
-      ask_about = TRUE;
-      arg = arg+6;
-    }
-
-    if(!*arg)
-      send_to_char(ch, "What did you want to ask %s?\r\n", name);
-    else {
-      CHAR_DATA *tgt = generic_find(ch, name,
-				    FIND_TYPE_CHAR,
-				    FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
-				    FALSE, NULL);
-
-      if(tgt == NULL)
-	send_to_char(ch, "Who were you trying to ask a question?\r\n");
-      else if(tgt == ch)
-	send_to_char(ch, "You have a nice conversation with yourself.\r\n");
-      else {
-	char other_buf[MAX_BUFFER];
-	sprintf(other_buf, "{w$n asks you%s, '%s'{n",
-		(ask_about ? " about" : ""), arg);
-	message(ch, tgt, NULL, NULL, FALSE, TO_VICT, other_buf);	
-
-	send_to_char(ch, "{wYou ask %s%s, '%s'{n\r\n", 
-		     charGetName(tgt), (ask_about ? " about" : ""), arg);
-
-	try_speech_script(ch, tgt, arg);
-
-	// see if the NPC has something to say in return
-	if(!try_dialog(ch, tgt, arg))
-	  message(ch, tgt, NULL, NULL, TRUE, TO_CHAR,
-		  "{p$N shrugs at the question.");
-      }
-    }
-  }
+COMMAND(cmd_ask) {
+  CHAR_DATA *tgt = NULL;
+  char *question = NULL;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "ch.room.noself [about] string", 
+		 &tgt, &question))
+    return;
+
+  mssgprintf(ch, tgt, NULL, NULL, FALSE, TO_VICT, 
+	     "{w$n asks you, '%s'{n", question);
+  mssgprintf(ch, tgt, NULL, NULL, FALSE, TO_CHAR,
+	     "{wYou ask $N, '%s'{n", question);
+  hookRun("ask", ch, tgt, arg);
 }
 
 
@@ -86,143 +45,72 @@
 // cmd_tell sends a message to another character. Primarily intended for
 // player-player communication. Players can tell other players things even
 // if they are not in the same room.
-//   usage: tell [person] [mesage]
+//   usage: tell <person> <mesage>
 //
 //   examples:
 //     tell luke I am your father
-//
-COMMAND(cmd_tell)
-{
-  if(!arg || !*arg)
-    send_to_char(ch, "Tell who what?\r\n");
-  else {
-    char name[MAX_BUFFER];
-    arg = one_arg(arg, name);
-    trim(arg);
-    if(!*arg)
-      send_to_char(ch, "What did you want to tell %s?\r\n", name);
-    else {
-      CHAR_DATA *tgt = generic_find(ch, name,
-				    FIND_TYPE_CHAR,
-				    FIND_SCOPE_WORLD | FIND_SCOPE_VISIBLE,
-				    FALSE, NULL);
-
-      if(tgt == NULL)
-	send_to_char(ch, "Who were you trying to talk to?\r\n");
-      else if(tgt == ch)
-	send_to_char(ch, "You have a nice conversation with yourself.\r\n");
-      else {
-	send_to_char(ch, "{rYou tell %s, '%s'{n\r\n", charGetName(tgt), arg);
-
-	// if we're an NPC, make sure we do colored output
-	char *color_arg = arg;
-	if(charIsNPC(ch)) {
-	  DIALOG_DATA *dialog = worldGetDialog(gameworld, charGetDialog(tgt));
-	  if(dialog)
-	    color_arg = tagResponses(dialog, arg, "{c", "{r");
-	}
-
-	char other_buf[MAX_BUFFER];
-	sprintf(other_buf, "{r$n tells you, '%s'{n", arg);
-	message(ch, tgt, NULL, NULL, FALSE, TO_VICT, other_buf);
-
-	if(color_arg != arg) 
-	  free(color_arg);
-      }
-    }
-  }
+COMMAND(cmd_tell) {
+  CHAR_DATA *tgt = NULL;
+  char     *mssg = NULL;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "ch.world.noself string", &tgt, &mssg))
+    return;
+
+  mssgprintf(ch, tgt, NULL, NULL, FALSE, TO_CHAR,
+	     "{rYou tell $N, '%s'{n", mssg);
+  mssgprintf(ch, tgt, NULL, NULL, FALSE, TO_VICT, 
+	     "{r$n tells you, '%s'{n", mssg);
 }
 
 
 //
 // cmd_chat sends a global message to all of the players currently logged on.
-//   usage: chat [message]
+//   usage: chat <message>
 //
 //   example:
 //     chat hello, world!
-//
 COMMAND(cmd_chat) {
-  if (!arg || !*arg) {
+  if (!arg || !*arg)
     send_to_char(ch, "Chat what?\n\r");
-    return;
-  }
-  communicate(ch, arg, COMM_GLOBAL);
+  else
+    communicate(ch, arg, COMM_GLOBAL);
 }
 
 
 //
 // cmd_say sends a message to everyone in the same room as you. Say, like ask,
 // can trigger NPC dialogs.
-//   usage: say [message]
+//   usage: say <message>
 //
 //   example:
 //     say hello, room!
-//
 COMMAND(cmd_say) {
-  if (!*arg) {
+  if (!*arg)
     send_to_char(ch, "Say what?\n\r");
-    return;
-  }
-
-  char *color_arg = arg;
-  if(charIsNPC(ch)) {
-    DIALOG_DATA *dialog = worldGetDialog(gameworld, charGetDialog(ch));
-    if(dialog)
-      color_arg = tagResponses(dialog, arg, "{c", "{y");
+  else {
+    communicate(ch, arg, COMM_LOCAL);
+    hookRun("say", ch, NULL, arg);
   }
-
-  communicate(ch, color_arg, COMM_LOCAL);
-  if(color_arg != arg) free(color_arg);
 }
 
 
 //
 // NPCs with dialogs will often have something to say when you greet/approach
 // then. cmd_greet is a way to get them talking.
-//   usage: greet [person]
+//   usage: greet <person>
 //
 //   examples:
 //     greet mayor
-//
 COMMAND(cmd_greet) {
-  if(!arg || !*arg)
-    send_to_char(ch, "Whom did you want to greet?\r\n");
-  else {
-    CHAR_DATA *tgt = generic_find(ch, arg,
-				  FIND_TYPE_CHAR,
-				  FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
-				  FALSE, NULL);
-
-    if(tgt == NULL)
-      send_to_char(ch, "Who were you trying to greet?\r\n");
-    else if(tgt == ch)
-      send_to_char(ch, 
-		   "You shake your left hand with your right hand and say, "
-		   "'nice to meet you, self'\r\n");
-    else {
-      message(ch, tgt, NULL, NULL, FALSE, TO_CHAR, "{wYou greet $N.");
-      message(ch, tgt, NULL, NULL, FALSE, TO_VICT, "{w$n greets you.");
-      message(ch, tgt, NULL, NULL, FALSE, TO_ROOM, "$n greets $N.");
-      
-      // see if the NPC has something to say in return
-      if(charIsNPC(tgt)) {
-	DIALOG_DATA *dialog = worldGetDialog(gameworld, charGetDialog(tgt));
-	
-	// Do we have something to say, back?
-	if(dialog && *dialogGetGreet(dialog)) {
-	  char *response = tagResponses(dialog,
-					dialogGetGreet(dialog),
-					"{c", "{p");
-	  send_to_char(ch, "{p%s responds, '%s'\r\n",charGetName(tgt),response);
-	  free(response);
-	}
-
-	else
-	  send_to_char(ch, "{p%s does not have anything to say.\r\n",
-		       charGetName(tgt));
-      }
-    }
-  }
+  CHAR_DATA *tgt = NULL;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "ch.room.noself", &tgt))
+    return;
+
+  message(ch, tgt, NULL, NULL, FALSE, TO_CHAR, "{wYou greet $N.");
+  message(ch, tgt, NULL, NULL, FALSE, TO_VICT, "{w$n greets you.");
+  message(ch, tgt, NULL, NULL, FALSE, TO_ROOM, "$n greets $N.");
+  hookRun("greet", ch, tgt, NULL);
 }
 
 
@@ -230,12 +118,11 @@
 // Send a special text message to the room you are in. The message is preceded
 // by your name, unless you put a $n somewhere in the text, in which case the
 // $n is replaced by your name.
-//   usage: emote [message]
+//   usage: emote <message>
 //
 //   examples:
 //     emote does a little dance.
 //     emote A gunshot sounds, and $n is laying on the ground, dead.
-//
 COMMAND(cmd_emote) {
   if(!arg || !*arg)
     send_to_char(ch, "Emote we must, but emote what?\r\n");
@@ -257,40 +144,27 @@
 
 //
 // cmd_gemote is similar to emote, but it sends a global message
-//
 COMMAND(cmd_gemote) {
   if(!arg || !*arg)
     send_to_char(ch, "Gemote we must, but gemote what?\r\n");
-  else {
-    char buf[MAX_BUFFER];
-    if(strfind(arg, "$n"))
-      sprintf(buf, "{bGLOBAL:{c %s{n", arg);
-    else
-      sprintf(buf, "{bGLOBAL:{c $n %s{n", arg);
-
-    message(ch, NULL, NULL, NULL, FALSE, TO_WORLD | TO_CHAR, buf);
-  }
+  else if(strfind(arg, "$n"))
+    mssgprintf(ch, NULL, NULL, NULL, FALSE, TO_WORLD | TO_CHAR,
+	       "{bGLOBAL:{c %s{n", arg);
+  else 
+    mssgprintf(ch, NULL, NULL, NULL, FALSE, TO_WORLD | TO_CHAR,
+	       "{bGLOBAL:{c $n %s{n", arg);
 }
 
 
 //
 // Send a message to another character, and also make it beep
-//
 COMMAND(cmd_page) {
   CHAR_DATA *tgt = NULL;
-  char name[SMALL_BUFFER];
-  arg = one_arg(arg, name);
+  char     *mssg = NULL;
 
-  if(!*name)
-    send_to_char(ch, "Page whom?\r\n");
-  else if( (tgt = generic_find(ch, name, FIND_TYPE_CHAR, 
-			       FIND_SCOPE_ALL | FIND_SCOPE_VISIBLE,
-			       FALSE, NULL)) == NULL)
-    send_to_char(ch, "Who were you looking for?\r\n");
-  else if(ch == tgt)
-    send_to_char(ch, "What did you want to let yourself know?\r\n");
-  else {
-    send_to_char(ch,  "\007\007You page %s.\r\n", see_char_as(ch, tgt));
-    send_to_char(tgt, "\007\007*%s* %s\r\n", see_char_as(tgt, ch), arg);
-  }
+  if(!parse_args(ch, TRUE, cmd, arg, "ch.world.noself string", &tgt, &mssg))
+    return;
+
+  send_to_char(ch,  "\007\007You page %s.\r\n", see_char_as(ch, tgt));
+  send_to_char(tgt, "\007\007*%s* %s\r\n", see_char_as(tgt, ch), mssg);
 }
diff -ruN ../nakedmudv2.7/src/cmd_manip.c src/cmd_manip.c
--- ../nakedmudv2.7/src/cmd_manip.c	Sun Jul 31 17:13:52 2005
+++ src/cmd_manip.c	Fri Oct  7 14:15:55 2005
@@ -16,7 +16,6 @@
 #include "exit.h"
 #include "world.h"
 #include "room.h"
-#include "extra_descs.h"
 #include "object.h"
 
 
@@ -43,57 +42,43 @@
   // see if there's a room on the other side
   ROOM_DATA         *to = worldGetRoom(gameworld, exitGetTo(exit));
   EXIT_DATA *other_exit = NULL;
+  const char   *opp_dir = NULL;
   if(to == NULL)
     return;
 
-  // check to see if we've specified the return direction
-  if(*exitGetOpposite(exit)) { 
-    int ex_dir_num = dirGetNum(exitGetOpposite(exit));
-    if(ex_dir_num == DIR_NONE)
-      other_exit = roomGetExitSpecial(to, exitGetOpposite(exit));
-    else
-      other_exit = roomGetExit(to, ex_dir_num);
-  }
-  // manually look it up...
+  // check to see if we can figure out a return direction
+  if(*exitGetOpposite(exit))
+    opp_dir = exitGetOpposite(exit);
   else {
-    int ex_dir_num = roomGetExitDir(room, exit);
-    // normal exit
-    if(ex_dir_num != DIR_NONE)
-      other_exit = roomGetExit(to, dirGetOpposite(ex_dir_num));
-  }
-
-  // did we find another exit?
-  if(other_exit != NULL) {
-    // are we changing the close state?
-    if(exitIsClosed(other_exit) != closed) {
-      // first, make sure it's not locked
-      if(!exitIsLocked(other_exit)) {
-	// only send messages if we're changing the state
-	if(exitIsClosed(other_exit) != closed) {
-	  exitSetClosed(other_exit, closed);
-	  send_to_list(roomGetCharacters(to),
-		       "%s %s from the other side.\r\n",
-		       (*exitGetName(other_exit)?exitGetName(other_exit):
-			"An exit"),
-		       (closed ? "closes" : "opens"));
-	}
-      }
-    }
-
-    // are we changing the lock state?
-    if(exitIsLocked(other_exit) != locked) {
-      // first make sure it's closed
-      if(exitIsClosed(other_exit)) {
-	// only send messages if we're changing the state
-	if(exitIsLocked(other_exit) != locked) {
-	  exitSetLocked(other_exit, locked);
-	  send_to_list(roomGetCharacters(to),
-		       "%s %s from the other side.\r\n",
-		       (*exitGetName(other_exit)?exitGetName(other_exit):
-			"An exit"),
-		       (locked ? "locks" : "unlocks"));
-	}
-      }
+    int opp_num = dirGetNum(roomGetExitDir(room, exit));
+    if(opp_num != DIR_NONE)
+      opp_dir = dirGetName(dirGetOpposite(opp_num));
+  }
+
+  // do we have an opposite direction to manipulate?
+  if(opp_dir == NULL)
+    return;
+
+  // do we have an opposite exit to manipulate?
+  if( (other_exit = roomGetExit(to, opp_dir)) != NULL) {
+    // are we changing the close state, and the exit's not locked?
+    if(exitIsClosed(other_exit) != closed && !exitIsLocked(other_exit)) {
+      exitSetClosed(other_exit, closed);
+      send_to_list(roomGetCharacters(to),
+		   "%s %s from the other side.\r\n",
+		   (*exitGetName(other_exit)?exitGetName(other_exit):
+		    "An exit"),
+		   (closed ? "closes" : "opens"));
+    }
+
+    // are we changing the lock state, and the exit is closed?
+    if(exitIsLocked(other_exit) != locked && exitIsClosed(other_exit)) {
+      exitSetLocked(other_exit, locked);
+      send_to_list(roomGetCharacters(to),
+		   "%s %s from the other side.\r\n",
+		   (*exitGetName(other_exit)?exitGetName(other_exit):
+		    "An exit"),
+		   (locked ? "locks" : "unlocks"));
     }
   }
 }
@@ -110,36 +95,29 @@
 // immediate visible range (room, inventory, body). do_lock automatically
 // checks if we have the key on us.
 //
-//  usage: lock [thing]
-//
 //  examples:
 //    lock door                lock a door in the room
 //    lock south               lock the south exit
 //    lock 2.chest             lock the 2nd chest in our visible range
-//
 COMMAND(cmd_lock) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What were you wanting to lock?\r\n");
-    return;
-  }
-
-  int found_type = FOUND_NONE;
-  void *found    = generic_find(ch, arg,
-				FIND_TYPE_OBJ | FIND_TYPE_EXIT, 
-				FIND_SCOPE_IMMEDIATE,
-				FALSE, &found_type);
+  int found_type = PARSE_NONE;
+  void    *found = NULL;
 
+  if(!parse_args(ch, TRUE, cmd, arg, "[the] { obj.room.inv.eq exit }", 
+		 &found, &found_type))
+    return;
 
-  // did we find something?
-  if(found && found_type == FOUND_EXIT) {
+  // did we find an exit or an object?
+  if(found_type == PARSE_EXIT) {
     if(!exitIsClosed(found))
       send_to_char(ch, "%s must be closed first.\r\n", exitGetName(found));
     else if(exitIsLocked(found))
       send_to_char(ch, "%s is already locked.\r\n", exitGetName(found));
-    else if(exitGetKey(found) == NOTHING)
+    else if(!*exitGetKey(found))
       send_to_char(ch, "You cannot figure out how %s would be locked.\r\n",
 		   exitGetName(found));
-    else if(!has_obj(ch, exitGetKey(found)))
+    else if(!has_obj(ch, get_fullkey_relative(exitGetKey(found), 
+			     get_key_locale(roomGetClass(charGetRoom(ch))))))
       send_to_char(ch, "You cannot seem to find the key.\r\n");
     else {
       send_to_char(ch, "You lock %s.\r\n", exitGetName(found));
@@ -153,17 +131,19 @@
     }
   }
 
-  else if(found && found_type == FOUND_OBJ) {
+  // object found
+  else { // if(found_type == PARSE_OBJ) {
     if(!objIsType(found, "container"))
       send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
     else if(!containerIsClosed(found))
       send_to_char(ch, "%s must be closed first.\r\n", objGetName(found));
     else if(containerIsLocked(found))
       send_to_char(ch, "%s is already locked.\r\n", objGetName(found));
-    else if(containerGetKey(found) == NOTHING)
+    else if(!*containerGetKey(found))
       send_to_char(ch, "You cannot figure out how %s would be locked.\r\n",
 		   objGetName(found));
-    else if(!has_obj(ch, containerGetKey(found)))
+    else if(!has_obj(ch, get_fullkey_relative(containerGetKey(found),
+				     get_key_locale(objGetClass(found)))))
       send_to_char(ch, "You cannot seem to find the key.\r\n");
     else {
       send_to_char(ch, "You lock %s.\r\n", objGetName(found));
@@ -171,36 +151,28 @@
       containerSetLocked(found, TRUE);
     }
   }
-  else
-    send_to_char(ch, "What did you want to lock?\r\n");
 }
 
 
-
 //
 // the opposite of lock
-//
 COMMAND(cmd_unlock) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What were you wanting to unlock?\r\n");
-    return;
-  }
-
-  int found_type = FOUND_NONE;
-  void *found    = generic_find(ch, arg,
-				FIND_TYPE_OBJ | FIND_TYPE_EXIT, 
-				FIND_SCOPE_IMMEDIATE,
-				FALSE, &found_type);
+  int found_type = PARSE_NONE;
+  void    *found = NULL;
 
+  if(!parse_args(ch, TRUE, cmd, arg, "[the] { obj.room.inv exit }", 
+		 &found, &found_type))
+    return;
 
   // did we find something?
-  if(found && found_type == FOUND_EXIT) {
+  if(found_type == PARSE_EXIT) {
     if(!exitIsLocked(found))
       send_to_char(ch, "%s is not locked.\r\n", exitGetName(found));
-    else if(exitGetKey(found) == NOTHING)
+    else if(!*exitGetKey(found))
       send_to_char(ch, "You cannot figure out how %s would be unlocked.\r\n",
 		   exitGetName(found));
-    else if(!has_obj(ch, exitGetKey(found)))
+    else if(!has_obj(ch, get_fullkey_relative(exitGetKey(found), 
+			     get_key_locale(roomGetClass(charGetRoom(ch))))))
       send_to_char(ch, "You cannot seem to find the key.\r\n");
     else {
       send_to_char(ch, "You unlock %s.\r\n", exitGetName(found));
@@ -214,15 +186,16 @@
     }
   }
 
-  else if(found && found_type == FOUND_OBJ) {
+  else { // if(found_type == PARSE_OBJ) {
     if(!objIsType(found, "container"))
       send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
     else if(!containerIsLocked(found))
       send_to_char(ch, "%s is not locked.\r\n", objGetName(found));
-    else if(containerGetKey(found) == NOTHING)
+    else if(!*containerGetKey(found))
       send_to_char(ch, "You cannot figure out how %s would be unlocked.\r\n",
 		   objGetName(found));
-    else if(!has_obj(ch, containerGetKey(found)))
+    else if(!has_obj(ch, get_fullkey_relative(containerGetKey(found), 
+				     get_key_locale(objGetClass(found)))))
       send_to_char(ch, "You cannot seem to find the key.\r\n");
     else {
       send_to_char(ch, "You unlock %s.\r\n", objGetName(found));
@@ -230,61 +203,39 @@
       containerSetLocked(found, FALSE);
     }
   }
-  else
-    send_to_char(ch, "What did you want to unlock?\r\n");
 }
 
 
-
-
 //
 //  put one thing into another. The thing you wish to put must be in
 //  your inventory. The container must be in your immediate visible range
 //  (room, inventory, body)
 //
-//  usage: put [thing] [container]
+//  usage: put [the] <thing> [in the] <container>
 //
 //  examples:
 //    put coin bag             put a coin into the bag
 //    put all.shirt closet     put all of the shirts in the closet
-//
 COMMAND(cmd_put) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "Put what where?\r\n");
-    return;
-  }
-
-  // get the name of what we're trying to move
-  char name[SMALL_BUFFER];
-  arg = one_arg(arg, name);
+  void    *found = NULL;
+  bool  multiple = FALSE;
+  OBJ_DATA *cont = NULL;
 
-  int found_type = FOUND_NONE;
-  void *found    = generic_find(ch, name,
-				FIND_TYPE_OBJ, 
-				FIND_SCOPE_INV | FIND_SCOPE_VISIBLE,
-				TRUE, &found_type);
-
-  OBJ_DATA *cont = generic_find(ch, arg,
-				FIND_TYPE_OBJ, FIND_SCOPE_IMMEDIATE,
-				FALSE, NULL);
-
-  // make sure we've got what we need
-  if(!found || !cont) {
-    send_to_char(ch, "Put what where?\r\n");
+  if(!parse_args(ch, TRUE, cmd, arg, 
+		 "[the] obj.inv.multiple [in the] obj.room.inv",
+		 &found, &multiple, &cont))
     return;
-  }
-
+  
   // make sure we have a container
-  if(!objIsType(cont, "container")) {
+  if(!objIsType(cont, "container"))
     send_to_char(ch, "%s is not a container.\r\n", objGetName(cont));
-    return;
-  }
 
   // did we find a list of things or a single item?
-  if(found_type == FOUND_OBJ)
+  else if(multiple == FALSE)
     do_put(ch, found, cont);
+
   // we have to move a bunch of things
-  else if(found_type == FOUND_LIST) {
+  else {
     OBJ_DATA *obj = NULL;
     while( (obj = listPop(found)) != NULL)
       do_put(ch, obj, cont);
@@ -297,7 +248,7 @@
 //  attempt to open a door or container. The container must be in our immediate
 //  visible range (room, inventory, body).
 //
-//  usage: open [thing]
+//  usage: open [the] <thing>
 //
 //  examples:
 //    open door               open a door
@@ -305,19 +256,15 @@
 //    open east               open the east exit
 //    open backpack on self   open a backpack you are wearing
 COMMAND(cmd_open) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What did you want to open?\r\n");
-    return;
-  }
+  void    *found = NULL;
+  int found_type = PARSE_NONE;
 
-  int found_type = FOUND_NONE;
-  void *found = generic_find(ch, arg,
-			     FIND_TYPE_OBJ | FIND_TYPE_EXIT,
-			     FIND_SCOPE_IMMEDIATE,
-			     FALSE, &found_type);
+  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room.inv.eq exit }",
+		 &found, &found_type))
+    return;
 
   // open an exit
-  if(found && found_type == FOUND_EXIT) {
+  if(found_type == PARSE_EXIT) {
     if(!exitIsClosable(found))
       send_to_char(ch, "But %s cannot be opened!\r\n",
 		   (*exitGetName(found) ? exitGetName(found) : "it"));
@@ -340,7 +287,7 @@
   }
 
   // open a container
-  else if(found && found_type == FOUND_OBJ) {
+  else { // if(found_type == FOUND_OBJ) {
     // make sure it's a container and it can be opened
     if(!objIsType(found, "container") || !containerIsClosable(found))
       send_to_char(ch, "But it cannot be opened!\r\n");
@@ -354,35 +301,28 @@
       containerSetClosed(found, FALSE);
     }
   }
-  else
-    send_to_char(ch, "What did you want to open?\r\n");
 }
 
 
 //
 // cmd_close is used to close containers and exits.
-//   usage: open [thing]
+//   usage: open <thing>
 //
 //   examples:
 //     close door               close a door
 //     close 2.bag              close your second bag
 //     close east               close the east exit
 //     close backpack on self   close a backpack you are wearing
-//
 COMMAND(cmd_close) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What did you want to close?\r\n");
-    return;
-  }
+  void    *found = NULL;
+  int found_type = PARSE_NONE;
 
-  int found_type = FOUND_NONE;
-  void *found = generic_find(ch, arg,
-			     FIND_TYPE_OBJ | FIND_TYPE_EXIT,
-			     FIND_SCOPE_IMMEDIATE,
-			     FALSE, &found_type);
+  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room.eq.inv exit }",
+		 &found, &found_type))
+    return;
 
   // close an exit
-  if(found && found_type == FOUND_EXIT) {
+  if(found_type == PARSE_EXIT) {
     if(!exitIsClosable(found))
       send_to_char(ch, "But %s cannot be closed!\r\n",
 		   (*exitGetName(found) ? exitGetName(found) : "it"));
@@ -404,7 +344,7 @@
   }
 
   // close a container
-  else if(found && found_type == FOUND_OBJ) {
+  else { // if(found_type == PARSE_OBJ) {
     // make sure it's a container and it can be closed
     if(!objIsType(found, "container") || !containerIsClosable(found))
       send_to_char(ch, "But it cannot even be closed!\r\n");
@@ -416,20 +356,17 @@
       containerSetClosed(found, TRUE);
     }
   }
-  else
-    send_to_char(ch, "What did you want to close?\r\n");
 }
 
 
 //
 // cmd_get is used to move objects from containers or the room to your inventory
-//   usage: get [object] [from]
+//   usage: get <object> <from>
 //
 //   examples:
 //     get sword            get a sword from the room
 //     get 2.cupcake bag    get the second cupcake from your bag
 //     get all.coin         get all of the coins on the ground
-//
 COMMAND(cmd_get) {
   if(!arg || !*arg) {
     send_to_char(ch, "What did you want to get?\r\n");
@@ -475,11 +412,11 @@
     get_count(name, name, &count);
     if(count == COUNT_ALL) {
       found_type = FOUND_LIST;
-      found      = find_all_objs(ch, objGetContents(cont), name, NOTHING, TRUE);
+      found      = find_all_objs(ch, objGetContents(cont), name, NULL, TRUE);
     }
     else {
       found_type = FOUND_OBJ;
-      found      = find_obj(ch, objGetContents(cont), count, name,NOTHING,TRUE);
+      found      = find_obj(ch, objGetContents(cont), count, name, NULL, TRUE);
     }
   }
   // otherwise, search the room for visible things
@@ -506,83 +443,68 @@
 //
 // cmd_give is used to transfer an object in your possession to 
 // another character
-//   usage: give [object] [person]
+//   usage: give [the] <object> [to] <person>
 //
 //   examples:
 //     give doll girl           give a doll in your inventory to a girl
 //     give all.coin robber     give all of your money to the robber
 //
 COMMAND(cmd_give) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "Give what to whom?\r\n");
-    return;
-  }
-  
-  strip_word(arg, "to");
-  char obj_name[SMALL_BUFFER];
-  arg = one_arg(arg, obj_name);
-
-  int found_type = FOUND_NONE;
-  void *found = generic_find(ch, obj_name, 
-			     FIND_TYPE_OBJ, 
-			     FIND_SCOPE_INV | FIND_SCOPE_VISIBLE, 
-			     TRUE, &found_type);
-
-  CHAR_DATA *recv = generic_find(ch, arg,
-				 FIND_TYPE_CHAR,
-				 FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
-				 FALSE, NULL);
-
-  if(!recv)
-    send_to_char(ch, "Whom where you looking for?\r\n");
-  else if(recv == ch)
-    send_to_char(ch, "You don't need to give yourself anything!\r\n");
-  else if(found && found_type == FOUND_LIST) {
-    OBJ_DATA *obj = NULL;
-    while( (obj = listPop(found)) != NULL)
+  CHAR_DATA *recv = NULL;  // the person we're giving stuff to
+  void   *to_give = NULL;  // may be a list or a single item
+  bool   multiple = FALSE; // are we giving one or multiple items?
+
+  // try to give objects from our inventory. We can give multiple items. Give
+  // them to a person in the room who is not ourself. The fact we can see the
+  // receiver is implied. If we fail to find our items or receiver, parse_args
+  // will tell the character what he did wrong, and we will halt the command
+  if(!parse_args(ch,TRUE,cmd,arg, "[the] obj.inv.multiple [to] ch.room.noself",
+		 &to_give, &multiple, &recv))
+    return;
+
+  // just a single item to give...
+  if(multiple == FALSE)
+    do_give(ch, recv, to_give);
+  // we have a list of items to give
+  else {
+    LIST_ITERATOR *obj_i = newListIterator(to_give);
+    OBJ_DATA        *obj = NULL;
+    ITERATE_LIST(obj, obj_i) {
       do_give(ch, recv, obj);
-    deleteList(found);
-  }
-  else if(found && found_type == FOUND_OBJ) {
-    do_give(ch, recv, found);
+    } deleteListIterator(obj_i);
+
+    // we also have to delete the list that parse_args sent us
+    deleteList(to_give);
   }
-  else
-    send_to_char(ch, "Give what to whom?\r\n");
 }
 
 
 //
 // cmd_drop is used to transfer an object in your inventory to the ground
-//   usage: drop [item]
+//   usage: drop <item>
 //
 //   examples:
 //     drop bag          drop a bag you have
 //     drop all.bread    drop all of the bread you are carrying
 //     drop 2.cupcake    drop the second cupcake in your posession
-//
 COMMAND(cmd_drop) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What did you want to drop?\r\n");
+  void   *found = NULL;
+  bool multiple = FALSE;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "[the] obj.inv.multiple",&found,&multiple))
     return;
-  }
 
-  int found_type = FOUND_NONE;
-  void *found    = generic_find(ch, arg,
-				FIND_TYPE_OBJ,
-				FIND_SCOPE_INV | FIND_SCOPE_VISIBLE,
-				TRUE, &found_type);
+  // are we dropping a list of things, or just one?
+  if(multiple == FALSE)
+    do_drop(ch, found);
 
   // we got a list of things... drop 'em all
-  if(found_type == FOUND_LIST && found) {
+  else {
     OBJ_DATA *obj = NULL;
     while( (obj = listPop(found)) != NULL)
       do_drop(ch, obj);
     deleteList(found);
   }
-  else if(found_type == FOUND_OBJ && found)
-    do_drop(ch, found);
-  else 
-    send_to_char(ch, "You can't find what you're looking for.\r\n");
 }
 
 
@@ -596,64 +518,53 @@
 //                                           inventory
 //     wear gloves left hand, right hand     wear the gloves on your left and
 //                                           right hands
-//
 COMMAND(cmd_wear) {
-  if(!*arg)
-    send_to_char(ch, "Wear what where?\r\n");
-  else {
-    char pos[MAX_BUFFER];
-    arg = one_arg(arg, pos);
-  
-    int found_type = FOUND_NONE;
-    void *found = generic_find(ch, pos,
-			       FIND_TYPE_OBJ,
-			       FIND_SCOPE_INV | FIND_SCOPE_VISIBLE,
-			       TRUE, &found_type);
-
-    if(found && found_type == FOUND_LIST) {
-      OBJ_DATA *obj = NULL;
-      while( (obj = listPop(found)) != NULL)
-	do_wear(ch, obj, arg);
-      deleteList(found);
-    }
+  void   *found = NULL;
+  bool multiple = FALSE;
+  char   *where = NULL;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "[the] obj.inv.multiple | [on my] string", 
+		 &found, &multiple, &where))
+    return;
 
-    else if(found && found_type == FOUND_OBJ)
-      do_wear(ch, found, arg);
+  // are we wearing one thing, or multiple things?
+  if(multiple == FALSE)
+    do_wear(ch, found, where);
 
-    else
-      send_to_char(ch, "You can't find what you're looking for.\r\n");
+  // we're trying to wear multiple items
+  else {
+    OBJ_DATA *obj = NULL;
+    while( (obj = listPop(found)) != NULL)
+      do_wear(ch, obj, where);
+    deleteList(found);
   }
 }
 
 
 //
 // cmd_remove is used to unequip items on your body to your inventory
-//   usage: remove [item]
+//   usage: remove <item>
 //
 //   examples:
 //     remove mask             remove the mask you are wearing
 //     remove all.ring         remove all the rings you have on
 //     remove 2.ring           remove the 2nd ring you have equipped
-//
 COMMAND(cmd_remove) {
-  if(!*arg)
-    send_to_char(ch, "What did you want to remove?\r\n");
+  void   *found = NULL;
+  bool multiple = FALSE;
+
+  if(!parse_args(ch, TRUE, cmd, arg, "obj.eq.multiple", &found, &multiple))
+    return;
+
+  // are we trying to remove one thing, or multiple things?
+  if(multiple == FALSE)
+    do_remove(ch, found);
+
+  // removing multiple things...
   else {
-    int found_type = FOUND_NONE;
-    void *found = generic_find(ch, arg,
-			       FIND_TYPE_OBJ,
-			       FIND_SCOPE_WORN | FIND_SCOPE_VISIBLE,
-			       TRUE, &found_type);
-
-    if(found && found_type == FOUND_LIST) {
-      OBJ_DATA *obj = NULL;
-      while( (obj = listPop(found)) != NULL)
-	do_remove(ch, obj);
-      deleteList(found);
-    }
-    else if(found && found_type == FOUND_OBJ)
-      do_remove(ch, found);
-    else 
-      send_to_char(ch, "What did you want to remove?\r\n");
+    OBJ_DATA *obj = NULL;
+    while( (obj = listPop(found)) != NULL)
+      do_remove(ch, obj);
+    deleteList(found);
   }
 }
